HuRrIcAnE IM2 Battery Check v1.00


;  Author:               HuRrIcAnE
;  E-mail:               (hurricaneti83@hotmail.com)
:  Version:              1.00
;  First public release: 10/21/2000
;  Last modified:        August 12, 2000
;  Platform:             TI-OS
;  Size:                 450 bytes (not squished)




.NOLIST
#define equ .equ
#define EQU .equ
#define end .end
#include "ti83asm.inc"

.LIST
.org $9327

        im      1
        call    _clrScrnFull
        ld      hl,msg                  ; display name & author
        call    _puts
        call    _newline
        ld      hl,interrupt_start
        ex      de,hl
        ld      hl,$8484
        ld      b,5
compareloop:
        ld      a,(de)
        cp      (hl)
        jr      nz,enable
        inc     hl
        inc     de
        djnz    compareloop
        ld      hl,disabled
        call    _puts
        call    _newline
        ld      ($8486),a
        ret

enable:
        ld      hl,enabled
        call    _puts
        call    _newline
        ld      b,1
        ld      hl,$8300
        ld      a,h
        ld      (hl),$84
        ld      d,h
        ld      e,b
        ldir
        ld      hl,interrupt_start
        ld      de,$8484
        ld      bc,interrupt_end-interrupt_start
        ldir
        ld      i,a
        im      2
        


; >>------ INTERRUPT PROGRAM ------<<

interrupt_start:
        
        di
        ex      af,af'
        exx
        ld      a,($800A)               ; check for apd
        dec     a
        jr      z,interrupt_off         ; if apd is about to happen, then
                                        ; prevent it and shutdown the calc.

        ld      a,($8008)               ; check battery status
        ld      c,%01111111             ; update sprite
shiftloop:        
        srl     c
        sub     8
        jr      nc,shiftloop
        

; >>------ DRAW THE SPRITE ------<<


        ld      hl,sprite-interrupt_start+$8484
        push    hl
        ld      b,3
        ld      a,%11000000
        or      c
loop:        
        inc     hl
        ld      (hl),a
        djnz    loop
        pop     hl
        
        ld      b,5                     ; height of the sprite
        ld      a,$20+11                ; Set LCD coordinates
        out     ($10),a
        call    delay-interrupt_start+$8484
        ld      a,$80+59
        out     ($10),a

drawloop:
        call    delay-interrupt_start+$8484
        ld      a,(hl)
        inc     hl
        out     ($11),a
        djnz    drawloop


exit_interrupt:
        jp      $003A                   ; call standard interrupt handler

interrupt_off:
        ld      a,$74                   ; Turn calculator off
        ld      ($800A),a
        ld      a,$08
        out     (3),a
        ld      a,$01
        out     (3),a
        pop     hl
        exx
        ex      af,af'
        ei
        halt
        jp      $0038                   ; call standard interrupt handler


delay:
        inc     hl
        dec     hl
        ret

sprite:
        .db     %01111111
        .db     %11000001
        .db     %10000001
        .db     %11000001
        .db     %01111111

interrupt_end:

disabled:
        .db     "Disabled",0
enabled:
        .db     "Enabled",0
msg:
        .db     "BatteryCheck 0.9"
        .db     "By HuRrIcAnE",$00
.end
END
